# Rust Roguelike

A rogue-like game, implemented in Rust, with the `specs` ECS library, and `rltk` roguelike toolkit.

## Rust Setup
Follow the instructions on the [Getting Started](https://www.rust-lang.org/learn/get-started) page of the Rust language website.You should then have `rustup` and `cargo` available in your terminal. If you want to run on a Raspberry Pi, or via WebAseembly, you will also need `make`. 

## Running the game
`cargo run` or `make run`

### Running the game (Raspberry Pi)
`make run-pi`

## WebAssembly Build
* Install the WebAssembly target via rustup: `rustup target add wasm32-unknown-unknown`
* Install `wasm-bindgen`: `cargo install wasm-bindgen-cli`
* Run `make build-wasm`
* Serve the `wasm` folder with a web server (wasm will not work straight from the html file)

## Makefile
If you want to see what else you can run with Makefile, run `make help`. This will list commands and what they do.